from contextlib import asynccontextmanager

from fastapi import FastAPI

from .routers import auth_router, user_router


@asynccontextmanager
async def lifespan(app: FastAPI):
    print("Lifespan init")
    yield
    print("Lifespan exited")


def create_app() -> FastAPI:
    app = FastAPI(lifespan=lifespan)
    app.include_router(auth_router)
    app.include_router(user_router)
    return app
