from sqlalchemy import insert
from sqlalchemy.ext.asyncio.session import AsyncSession

from ..models import RefModel
from ..schemas import RefReadDTO, UserAuthDTO


class RefRepository:
    def __init__(self, session: AsyncSession):
        self.session = session

    async def add_ref(self, user: UserAuthDTO) -> RefReadDTO:
        stmt = insert(RefModel).values(referer=user.id, is_active=True, referals=[]).returning(RefModel)
        res = await self.session.execute(stmt)
        return RefReadDTO.model_validate(res.scalar_one())

    # async def delete_ref(self, filter: dict) -> UserReadDTO | None:
    #     stmt = select(UserModel).filter_by(**filter)
    #     res = await self.session.execute(stmt)
    #     res = res.scalar_one_or_none()
    #
    #     if res is not None:
    #         return UserReadDTO.model_validate(res)
    #     return None
